#!/usr/bin/env perl

use strict;
use warnings;
use FileHandle;

my ($bandsfn, $seqsfn) = @ARGV;


my $bandsfh = FileHandle->new($bandsfn) or die("$!");
my $seqsfh = FileHandle->new($seqsfn) or die("$!");

my $seen = {};

while (my $line = <$bandsfh>) {
    chomp $line;
    next unless $line =~ /^\d+$/;
    $seen->{$line} = 1;
}


while (my $line = <$seqsfh>) {
    my ($seq, $tag) = $line =~ /^(\w+)\s+(\d+)/;
    #print ":: $seq\t$tag\t$line";
    print "$seq\t$tag\n" if $seen->{$tag};
}
