#!/usr/bin/env perl


use strict;
use warnings;
use FileHandle;
use English;
use Data::Dumper;
use Carp;
use Getopt::Long;

my $verbose;
my @kickouts = ();
my @mapfn = ();
my $result = GetOptions (
			 "verbose"  => \$verbose,
			 "exclude-bac=s" => \@kickouts,
			 "rename=s" => \@mapfn,
			 
			 );  # flag




my $map = {};
foreach my $fn (@mapfn) {
    my $fh = FileHandle->new("$fn") or die("$!:$fn");
    foreach (<$fh>) {
	my ($from, $to) = split;
	$map->{$from} = $to;

	if ($from =~ /^\d/) {
	    $map->{'SP'.$from} = $to;
	}
    }
}


{
local $INPUT_RECORD_SEPARATOR = "-1\n";
while (my $rec = <>) {

    my ($top, $body) = split(/\n/, $rec, 2);
    my ($bac1, $count, $bac2) = $top =~ /(\S+)\s+(\d+)\s+(\S+)/;
    my @ids = $body =~ /(-?[\d]+)/g;
    my $last = pop @ids;
    if ($last != "-1") {
	Carp::confess();
      }
    
    my $skipbac = 0;
    foreach my $kickout (@kickouts) {
	if ($bac1 =~ /^${kickout}_/ ) {
	    $skipbac += 1;
	    last;
	}
    }
    
    next if $skipbac;
    

    my ($bacbase, $platepos) = $bac1 =~ /^(.*?)_(.*)$/;
    if (!$bacbase) {
	warn("mapping for $bac1 prob failed. expected X_Y");
    }


    my $outbac = $bac1;
    $outbac = $map->{$bacbase}."_$platepos" if $map->{$bacbase};


    print "$outbac $count $bac2\n";
    foreach my $tagid (@ids) {
	print "$tagid\n";
    }
    print "-1\n";
    
}

}
