use strict;
use warnings;
use WGP::Sequence::ApproxMatch;

my $in = $ARGV[0];

my @params = (
    query              => $in,  #input with primers/tags
    dc_template        => "./WGP-TeraBlastNH.tml", #use custom template
    dc_machine         => "electra",  #use electra server
    dc_target          => "FY_VEC_ECO_CPL_MIT",  #could be case sensitive, target reference databases, comma seperated
    min_perc_qcoverage => 95,   #Specify the minimum percent coverage of the query
    out                => $in . ".blast.out"  #output file
);
my $matchobj = WGP::Sequence::ApproxMatch->new(@params);
$matchobj->run_decypher;    #tera blastnh, fast approach

my $exitStat = `perl ./wgp_ReformatBlast.pl $in."blast.out" $in`;
