use strict;
use warnings;
use Kg::Tools::ParseFasta;
use Data::Dumper;

my $blastOut = $ARGV[0];
my $oriFnaSet = $ARGV[1];


open (BLT, $blastOut) or die "could not open blastoutput file" . $!;
open (FNA, $oriFnaSet) or die "could not open fna file" . $!;
open (KOUT, ">$oriFnaSet.kickout.txt") or die "could not open file for writing" . $!;
print KOUT "TAG\n";
my %excl;
while (<BLT>) {
    my @args =  split(/\t/);
    $excl{$args[0]} = 1;
}
close BLT;

my $fasta   = Kg::Tools::ParseFasta->new (\*FNA);
while ( my $entry = $fasta->nextEntry ) {
    my $seq  = $entry->seq;
    my $def  = $entry->def;
    my ($newdef) = $def =~ /^>(.+?)\W/;
    if (exists $excl{$newdef}) {
        print KOUT $seq . "\n";
        next;
    }
}
close FNA;
close KOUT;
