#!/usr/bin/env perl
use strict;
use warnings;
use FileHandle;
use English;
use Data::Dumper;
use Carp;



sub BACExtract {
    my ($fhin, $bacs) = @_;

    my $bac2thing = {};
    my $bac2tag = {};
    my $tag2bac = {};


    while (my $rec = <$fhin>) {
	my ($top, $body) = split(/\n/, $rec, 2);
	my ($bac1, $count, $aname) = $top =~ /([\w\d]+)\s+(\d+)\s+([\w\d_]+)/;

	my @tags = $body =~ /(-?[\d]+)/g;
	if (pop @tags != "-1") {
	    Carp::confess();
	}
	$bac2thing->{$bac1} = $aname;
	$bac2tag->{$bac1} = \@tags;

	foreach my $tag (@tags) {
	    push @{$tag2bac->{$tag}}, $bac1;
	}
    }



    my $wantedbacs = {};
    my $wantedtags = {};

    my @wantedbacs = ();
    foreach my $bac (@$bacs) {
	$wantedbacs->{$bac} = 0;
	push @wantedbacs, $bac;
    }

    
    while (@wantedbacs) {
	my $bac = shift @wantedbacs;
	my @wantedtags = @{$bac2tag->{$bac}};
	#print $#wantedbacs," bacs to go\n";

#	print "acquiring $bac\n";
	$wantedbacs->{$bac}= 1;

	foreach my $tag (@wantedtags) {
	    $wantedtags->{$tag} = 1;
	    my @inbacs = @{$tag2bac->{$tag}};
	    foreach my $bac2 (@inbacs) {
		
		if (! exists $wantedbacs->{$bac2}) {
		    $wantedbacs->{$bac2} = 0;
		    push @wantedbacs, $bac2;
#		    print "  also wanting bac $bac2\n";
		} else {
		    if ($wantedbacs->{$bac2}) {
#			print "  already got $bac2 ",$wantedbacs->{$bac2},"\n";
		    } else {
#			print "  not (yet) interest in $bac2 ",$wantedbacs->{$bac2},"\n";
		    }

		}
#		print "  -- bac2 $bac2\n";
	    }
#	    print " -- tag $tag\n";
	}
#	print "-- bac\n";
	
    }


#    print "END\n";
#    print scalar(keys %$wantedbacs)," bacs\n";
#    print scalar(keys %$wantedtags)," tags\n";
    #show($wantedbacs, $wantedtags, \@wantedbacs);

    foreach my $bac (sort keys %$wantedbacs) {

	my $thing = $bac2thing->{$bac};
	my @tags = @{$bac2tag->{$bac}};
	my $count = $#tags+1;
	push @tags, "-1";

	print "$bac $count $thing\n",join("\n",@tags),"\n";
	
    }

}











$INPUT_RECORD_SEPARATOR = "-1\n";

my $maxtagid = 65535;

my $infn = $ARGV[0];
my $bacname = $ARGV[1];

my $fh = FileHandle->new($infn);
BACExtract($fh, [$bacname]);


sub show {
    my ($wantedbacs, $wantedtags, $wantedbacs2) = @_;
    #print Dumper $wantedbacs, $wantedtags, $wantedbacs2;
    print Dumper $wantedbacs, $wantedbacs2;
}


