#!/usr/bin/perl

use strict;
#use warnings;
use Data::Dumper;
use FileHandle;

$/ = "\n  \n";






sub analyze {
    my ($fh) = @_;

    my $numBAC = 0;
    my $numMapped = 0;
    my $singletons = {};
    my $nonsingletons = {};
    my @names = ();
    my $out = {};


    while (my $rec = <$fh>) {
	#print "\n\n\n$rec\n\n-------------\n\n";
	next unless $rec =~ /^BAC :/;
	my ($name) = $rec =~ /BAC : "(.*?)"/;
	$numBAC++;
	
	if ($rec =~ /\nMap /) {
	    $numMapped++;
	    $nonsingletons->{$name} = 1;
	    $out->{$name} = "N";
	} else {
	    $out->{$name} = "S";
	    
	    $singletons->{$name} = 1;
	}
	push @names, $name;
    }
    
    print "$numMapped / $numBAC= ",100*$numMapped / $numBAC,"%\n";
#    foreach my $name (sort keys %$out) {
#	my $v = $out->{$name};
#	print "$name\t$v\n";
#    }

    return $out;
}



my $fh1 = FileHandle->new($ARGV[0]);
my $fh2 = FileHandle->new($ARGV[1]);

my $struct1 = analyze($fh1);
my $struct2 = analyze($fh2);


sub reportStructure {
    my ($s1, $s2) = @_;

    # calc all keys for both hashes
    my @keys = keys %$s1;
    foreach my $k (keys %$s2) {
	push @keys, $k unless $s1->{$k};
    }



    my $same = 0;
    my $different = 0;

    foreach my $key (@keys) {
	if ($s1->{$key} eq $s2->{$key}) {
	    #print "$key\tsame\t",$s1->{$key},"\n";
	    $same++;
	} else {
	    #print "$key\t",$s1->{$key},"\t",$s2->{$key},"\n";
	    $different++;
	}

    }
    
    print "same=$same\tdifferent=$different\n";


    foreach my $key (@keys) {
	if ($s1->{$key} eq $s2->{$key}) {
	    print "$key\tsame\t",$s1->{$key},"\n";
	    #$same++;
	} else {
	    print "$key\t",$s1->{$key},"\t",$s2->{$key},"\n";
	    #$different++;
	}

    }






}

reportStructure($struct1, $struct2);
#print Dumper $struct1;
#print Dumper $struct2;
