/*
 * DO NOT EDIT THIS FILE - it is generated by Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "fpp.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "mEdit_callbacks.h"
#include "mEdit_interface.h"

GtkWidget *markerEditWindow;


//#include "support.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  gtk_object_set_data_full (GTK_OBJECT (component), name, \
    gtk_widget_ref (widget), (GtkDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  gtk_object_set_data (GTK_OBJECT (component), name, widget)

void appendCloneToMarkerList(int cloneindex){
   CLONE *clone;
   gchar last;
   GtkTextBuffer* buffer;
   GtkTextIter it;

   buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(clonesTextview));

   gtk_text_buffer_get_end_iter(buffer,&it);
   gtk_text_iter_backward_char(&it);
   last = gtk_text_iter_get_char(&it);
   if(last != '\n')
      gtk_text_buffer_insert_at_cursor(buffer,"\n",-1);

   clone = arrp(acedata, cloneindex, CLONE);

   gtk_text_buffer_insert_at_cursor(buffer,clone->clone,-1);
   gtk_text_buffer_insert_at_cursor(buffer,"\n",-1);
}

void write_attached_clones(GtkWidget *text, int cloneindex, struct markerclone *nextclone){
   struct markerclone * clp;
   CLONE *clone;
    GtkTextBuffer* buffer;

    buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
    gtk_text_buffer_set_text(buffer,"",-1);


   clone = arrp(acedata, cloneindex, CLONE);
   if(clone==NULL) return;

   gtk_text_buffer_insert_at_cursor(buffer,clone->clone,-1);
   gtk_text_buffer_insert_at_cursor(buffer,"\n",-1);

   for (clp = nextclone; clp != NULL; clp = clp->nextclone){
      clone = arrp(acedata, clp->cloneindex, CLONE);
      if(clone==NULL) return;
        gtk_text_buffer_insert_at_cursor(buffer,clone->clone,-1);
        gtk_text_buffer_insert_at_cursor(buffer,"\n",-1);
   }
}

void write_attached_remarks(GtkWidget *text, struct remark *remark){
   struct remark *rmp;
    GtkTextBuffer* buffer;

    buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
    gtk_text_buffer_set_text(buffer,"",-1);


   for(rmp=remark;rmp!=NULL;rmp=rmp->next){
        gtk_text_buffer_insert_at_cursor(buffer,rmp->message,-1);
        gtk_text_buffer_insert_at_cursor(buffer,"\n",-1);
   }
}

GtkWidget*
create_help_window1 (void)
{
  GtkWidget *help_window1;
  GtkWidget *vbox2;
  GtkWidget *label2;
  GtkWidget *button1;

  help_window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (help_window1), 3);
  gtk_window_set_title (GTK_WINDOW (help_window1), ("Marker Edit Help"));

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (help_window1), vbox2);

  label2 = gtk_label_new (("Attaching a clone:\n   Enter one clone per line.  Type the clone name into the Clones text\n   box, or turn on the Pick toggle and select from the contig display or\n   keyset windows.\nDeleting a clone:\n   Remove the clone name from the Clones test box\n\nAttaching a remark:\n   Enter one remark per line.  Type remarks into the Remarks text box.\nDeleting a remark:\nRemove the remark from the Remarks text box.\n\nWhen attaching large numbers of clones or remarks, we suggest\nusing the functions from the 'File...' menu on the main window."));
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (vbox2), label2, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_LEFT);

  button1 = gtk_button_new_with_label (("OK"));
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (vbox2), button1, FALSE, FALSE, 2);

  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (on_help_ok_clicked),
                      NULL);

  gtk_widget_show(help_window1);
  return help_window1;
}

GtkWidget*
create_markerEditWindow (void)
{
  GtkWidget *vbox1;
  GtkWidget *titleLabel;
  GtkWidget *hbox1;
  GtkWidget *cloneLabel;
  GtkWidget *remarksLabel;
  GtkWidget *hbox2;
  GtkWidget *clonesScrolledWindow;
  GtkWidget *vseparator1;
  GtkWidget *remarksScrolledWindow;
  GtkWidget *hbox6;
  GtkWidget *hbox7;
  GtkWidget *pickClonesToggle;
  GtkWidget *hbox8;
  GtkWidget *hbox14;
  GtkWidget *markerTypeLabel;
  GtkWidget *menu1;
  GtkWidget *optionmenu1;
  GtkWidget *probe1;
  GtkWidget *sts1;
  GtkWidget *end1;
  GtkWidget *epcr1;
  GtkWidget *snp1;
  GtkWidget *yac1;
  GtkWidget *bac1;
  GtkWidget *pac1;
  GtkWidget *cdna1;
  GtkWidget *cosmid1;
  GtkWidget *fosmid1;
  GtkWidget *locus1;
  GtkWidget *clone1;
  GtkWidget *ebac1;
  GtkWidget *emrk1;
  GtkWidget *tc1;
  GtkWidget *ssr1;
  GtkWidget *rflp1;
  GtkWidget *overgo1;
  GtkWidget *rep1;
  GtkWidget *hbox5;
  GtkWidget *helpButton;
  GtkWidget *cancelButton;
  GtkWidget *applyButton;

  MARKER *marker;
  char markerTitle [MARKER_SZ + 8];

  if(active != EDITNOTHING){
     displaymess("Only one edit session allowed at a time");
     return NULL;
  }
  active += EDITMARKER;
  marker = arrp(markerdata,markerdisplayed,MARKER);

  tempMk.marker_index = markerdisplayed;
  tempMk.type = marker->type;

  markerEditWindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (markerEditWindow), 5);
  gtk_window_set_title (GTK_WINDOW (markerEditWindow), ("Marker Edit"));
  gtk_window_set_policy (GTK_WINDOW (markerEditWindow), FALSE, FALSE, TRUE);
  gtk_signal_connect (GTK_OBJECT (markerEditWindow), "destroy",
		      GTK_SIGNAL_FUNC (destroy_edit_marker_callback), NULL);

  vbox1 = gtk_vbox_new (FALSE, 10);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (markerEditWindow), vbox1);

  sprintf(markerTitle, "Marker %s",arrp(markerdata,markerdisplayed,MARKER)->marker);
  titleLabel = gtk_label_new (markerTitle);
  gtk_widget_show (titleLabel);
  gtk_box_pack_start (GTK_BOX (vbox1), titleLabel, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (titleLabel), GTK_JUSTIFY_LEFT);

  hbox1 = gtk_hbox_new (TRUE, 10);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);

  cloneLabel = gtk_label_new (("Clones"));
  gtk_widget_show (cloneLabel);
  gtk_box_pack_start (GTK_BOX (hbox1), cloneLabel, FALSE, FALSE, 0);

  remarksLabel = gtk_label_new (("Remarks"));
  gtk_widget_show (remarksLabel);
  gtk_box_pack_start (GTK_BOX (hbox1), remarksLabel, FALSE, FALSE, 0);

  hbox2 = gtk_hbox_new (FALSE, 15);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, TRUE, 0);

  clonesScrolledWindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (clonesScrolledWindow);
  gtk_box_pack_start (GTK_BOX (hbox2), clonesScrolledWindow, TRUE, TRUE, 0);
  gtk_widget_set_usize (clonesScrolledWindow, 189, 92);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (clonesScrolledWindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  clonesTextview = gtk_text_view_new ();
  gtk_widget_show (clonesTextview);
  gtk_container_add (GTK_CONTAINER (clonesScrolledWindow), clonesTextview);
  gtk_widget_set_usize (clonesTextview, -2, 90);
  gtk_text_view_set_editable(GTK_TEXT_VIEW(clonesTextview),TRUE); 
  write_attached_clones(clonesTextview, marker->cloneindex, marker->nextclone);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox2), vseparator1, FALSE, FALSE, 0);

  remarksScrolledWindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (remarksScrolledWindow);
  gtk_box_pack_start (GTK_BOX (hbox2), remarksScrolledWindow, TRUE, TRUE, 0);
  gtk_widget_set_usize (remarksScrolledWindow, 189, 90);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (remarksScrolledWindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  remarksTextview = gtk_text_view_new ();
  gtk_widget_show (remarksTextview);
  gtk_container_add (GTK_CONTAINER (remarksScrolledWindow), remarksTextview);
  gtk_text_view_set_editable(GTK_TEXT_VIEW(remarksTextview),TRUE); 
  write_attached_remarks(remarksTextview,marker->remark);

  hbox6 = gtk_hbox_new (TRUE, 45);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox6, FALSE, TRUE, 0);

  hbox7 = gtk_hbox_new (TRUE, 11);
  gtk_widget_show (hbox7);
  gtk_box_pack_start (GTK_BOX (hbox6), hbox7, FALSE, TRUE, 0);

  pickClonesToggle = gtk_toggle_button_new_with_label (("Pick from Contig display"));
  gtk_widget_show (pickClonesToggle);
  gtk_box_pack_start (GTK_BOX (hbox7), pickClonesToggle, FALSE, FALSE, 0);

  hbox8 = gtk_hbox_new (FALSE, 10);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (hbox6), hbox8, FALSE, TRUE, 0);
 
  hbox14 = gtk_hbox_new (FALSE, 14);
  gtk_widget_show (hbox14);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox14, FALSE, TRUE, 0);

  markerTypeLabel = gtk_label_new (("Marker Type:"));
  gtk_widget_show (markerTypeLabel);
  gtk_box_pack_start (GTK_BOX (hbox14), markerTypeLabel, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (markerTypeLabel), GTK_JUSTIFY_LEFT);

  optionmenu1 = gtk_option_menu_new ();
  gtk_widget_show (optionmenu1);
  gtk_box_pack_start (GTK_BOX (hbox14), optionmenu1, FALSE, FALSE, 0);

  menu1 = gtk_menu_new ();

  probe1 = gtk_menu_item_new_with_label(("Probe"));
  gtk_widget_show (probe1);
  gtk_container_add (GTK_CONTAINER (menu1), probe1);

  sts1 = gtk_menu_item_new_with_label(("STS"));
  gtk_widget_show (sts1);
  gtk_container_add (GTK_CONTAINER (menu1), sts1);

  end1 = gtk_menu_item_new_with_label(("End"));
  gtk_widget_show (end1);
  gtk_container_add (GTK_CONTAINER (menu1), end1);

  epcr1 = gtk_menu_item_new_with_label(("ePCR"));
  gtk_widget_show (epcr1);
  gtk_container_add (GTK_CONTAINER (menu1), epcr1);

  snp1 = gtk_menu_item_new_with_label(("SNP"));
  gtk_widget_show (snp1);
  gtk_container_add (GTK_CONTAINER (menu1), snp1);

  yac1 = gtk_menu_item_new_with_label(("YAC"));
  gtk_widget_show (yac1);
  gtk_container_add (GTK_CONTAINER (menu1), yac1);

  bac1 = gtk_menu_item_new_with_label(("BAC"));
  gtk_widget_show (bac1);
  gtk_container_add (GTK_CONTAINER (menu1), bac1);

  pac1 = gtk_menu_item_new_with_label(("PAC"));
  gtk_widget_show (pac1);
  gtk_container_add (GTK_CONTAINER (menu1), pac1);

  cdna1 = gtk_menu_item_new_with_label(("cDNA"));
  gtk_widget_show (cdna1);
  gtk_container_add (GTK_CONTAINER (menu1), cdna1);

  cosmid1 = gtk_menu_item_new_with_label(("Cosmid"));
  gtk_widget_show (cosmid1);
  gtk_container_add (GTK_CONTAINER (menu1), cosmid1);

  fosmid1 = gtk_menu_item_new_with_label(("Fosmid"));
  gtk_widget_show (fosmid1);
  gtk_container_add (GTK_CONTAINER (menu1), fosmid1);

  locus1 = gtk_menu_item_new_with_label(("Locus"));
  gtk_widget_show (locus1);
  gtk_container_add (GTK_CONTAINER (menu1), locus1);

  clone1 = gtk_menu_item_new_with_label(("Clone"));
  gtk_widget_show (clone1);
  gtk_container_add (GTK_CONTAINER (menu1), clone1);

  ebac1 = gtk_menu_item_new_with_label(("eBAC"));
  gtk_widget_show (ebac1);
  gtk_container_add (GTK_CONTAINER (menu1), ebac1);

  emrk1 = gtk_menu_item_new_with_label(("eMRK"));
  gtk_widget_show (emrk1);
  gtk_container_add (GTK_CONTAINER (menu1), emrk1);

  tc1 = gtk_menu_item_new_with_label(("TC"));
  gtk_widget_show (tc1);
  gtk_container_add (GTK_CONTAINER (menu1), tc1);

  ssr1 = gtk_menu_item_new_with_label(("SSR"));
  gtk_widget_show (ssr1);
  gtk_container_add (GTK_CONTAINER (menu1), ssr1);

  rflp1 = gtk_menu_item_new_with_label(("RFLP"));
  gtk_widget_show (rflp1);
  gtk_container_add (GTK_CONTAINER (menu1), rflp1);

  overgo1 = gtk_menu_item_new_with_label(("OVERGO"));
  gtk_widget_show (overgo1);
  gtk_container_add (GTK_CONTAINER (menu1), overgo1);

  rep1 = gtk_menu_item_new_with_label(("REP"));
  gtk_widget_show (rep1);
  gtk_container_add (GTK_CONTAINER (menu1), rep1);

  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu1), menu1);


  hbox5 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox5, FALSE, TRUE, 0);

  applyButton = gtk_button_new_with_label(("Accept Edit"));
  gtk_widget_show (applyButton);
  gtk_box_pack_start (GTK_BOX (hbox5), applyButton, FALSE, FALSE, 0);

  cancelButton = gtk_button_new_with_label(("Reject Edit"));
  gtk_widget_show (cancelButton);
  gtk_box_pack_start (GTK_BOX (hbox5), cancelButton, FALSE, FALSE, 0);

  helpButton = gtk_button_new_with_label (("Help"));
  gtk_widget_show (helpButton);
  gtk_box_pack_start (GTK_BOX (hbox5), helpButton, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (pickClonesToggle), "toggled",
                      GTK_SIGNAL_FUNC (on_pickClonesToggle_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (probe1), "activate",
                      GTK_SIGNAL_FUNC (on_probe1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (sts1), "activate",
                      GTK_SIGNAL_FUNC (on_sts1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (end1), "activate",
                      GTK_SIGNAL_FUNC (on_end1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (epcr1), "activate",
                      GTK_SIGNAL_FUNC (on_epcr1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (snp1), "activate",
                      GTK_SIGNAL_FUNC (on_snp1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (yac1), "activate",
                      GTK_SIGNAL_FUNC (on_yac1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (bac1), "activate",
                      GTK_SIGNAL_FUNC (on_bac1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (pac1), "activate",
                      GTK_SIGNAL_FUNC (on_pac1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (cdna1), "activate",
                      GTK_SIGNAL_FUNC (on_cdna1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (cosmid1), "activate",
                      GTK_SIGNAL_FUNC (on_cosmid1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (fosmid1), "activate",
                      GTK_SIGNAL_FUNC (on_fosmid1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (locus1), "activate",
                      GTK_SIGNAL_FUNC (on_locus1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (clone1), "activate",
                      GTK_SIGNAL_FUNC (on_clone1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (ebac1), "activate",
                      GTK_SIGNAL_FUNC (on_ebac1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (emrk1), "activate",
                      GTK_SIGNAL_FUNC (on_emrk1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (tc1), "activate",
                      GTK_SIGNAL_FUNC (on_tc1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (ssr1), "activate",
                      GTK_SIGNAL_FUNC (on_ssr1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (rflp1), "activate",
                      GTK_SIGNAL_FUNC (on_rflp1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (overgo1), "activate",
                      GTK_SIGNAL_FUNC (on_overgo1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (rep1), "activate",
                      GTK_SIGNAL_FUNC (on_rep1_activate),
                      &(tempMk.type));
  gtk_signal_connect (GTK_OBJECT (helpButton), "clicked",
                      GTK_SIGNAL_FUNC (create_help_window1),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cancelButton), "clicked",
                      GTK_SIGNAL_FUNC (on_cancelButton_clicked),
                      markerEditWindow);
  gtk_signal_connect (GTK_OBJECT (applyButton), "clicked",
                      GTK_SIGNAL_FUNC (on_applyButton_clicked),
                      &tempMk);

  switch(marker->type){
     case markPROBE:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),0); break;
     case markSTS:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),1); break;
     case markEND:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),2); break;
     case markPCR:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),3); break;
     case markSNP:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),4); break;
     case markYAC:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),5); break;
     case markBAC:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),6); break;
     case markPAC:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),7); break;
     case markCDNA:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),8); break;
     case markCOSMID:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),9); break;
     case markFOSMID:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),10); break;
     case markLOCUS:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),11); break;
     case markCLONE:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),12); break;
     case markeBAC:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),13); break;
     case markeMRK:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),14); break;
     case markTC:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),15); break;
     case markSSR:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),16); break;
     case markRFLP:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),17); break;
     case markOVERGO:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),18); break;
     case markREP:  gtk_option_menu_set_history(GTK_OPTION_MENU (optionmenu1),19); break;
     default:       printf("ERROR -- marker type not identified\n");
  }

  return markerEditWindow;
}

